#include "device_message.h"
#include "gd32f10x.h"
#include "w25q32.h"

static CONFIG_PARAMS g_config_params = {0};


void write_struct_to_flash(uint32_t *data, int size);

/*
 *  save_config_params(CONFIG_PARAMS *params)
 *  
 *  
 *  ֵ
 *  ãhttpλò
 */
int save_config_params(CONFIG_PARAMS *params)
{
		if(params == NULL)
				return -1;
		
		CONFIG_PARAMS_UNION config_params_union;
		memset(&config_params_union, 0, sizeof(CONFIG_PARAMS_UNION));	
		memcpy(&config_params_union.config_params, params, sizeof(CONFIG_PARAMS)); 
		clear_gateway_config_block();
		write_struct_to_flash((uint32_t *)&config_params_union, sizeof(CONFIG_PARAMS_UNION));
		return 0;
}
/*
 *  load_config_params()
 *  
 *  
 *  ֵ
 *  ãhttpλò
 */
int load_config_params()
{	
		CONFIG_PARAMS_UNION config_params_union;
		memset(&config_params_union, 0, sizeof(CONFIG_PARAMS_UNION));//ԭ
		//w25q32ڲĽṹϢ
		W25Q32_Read((uint8_t *)&config_params_union, 0, sizeof(CONFIG_PARAMS_UNION)); //W25Q32жȡṹ
		memcpy(&g_config_params, &config_params_union.config_params, sizeof(CONFIG_PARAMS));
		uint8_t *ptr=(uint8_t *)&g_config_params;
	  //жϵһλǷЧ	
		if(*ptr == 0xF1)
		{
				return 0;
		}
		return -1;
}
/*
 *  CONFIG_PARAMS *get_config_params()
 *  
 *  
 *  ֵ
 *  ãȡò
 */
CONFIG_PARAMS *get_config_params()
{
		return &g_config_params;
}
/*
 *  void write_struct_to_flash(uint32_t *data, int size)
 *  *data,sizedataΪw25q32дݡsizeΪдݴС
 *  
 *  ֵ
 *  ãw25q32дݡһдһҳݡȳʱҪлҳ
 */
void write_struct_to_flash(uint32_t *data, int size)
{
		uint8_t *pdata = (uint8_t *)data;  
		//ݰҳдһд256ֽ
    for (int i = 0; i <= size / 256; i++) {
        W25Q32_PageWrite(pdata + i * 256, i); 
    }
}
/*
 *  clear_gateway_config_block(void)
 *  
 *  
 *  ֵ
 *  ãhttpȡĲ
 */
void clear_gateway_config_block(void)
{
	W25Q32_Erase64K(0);//һĴС
}


