#include "gd32f10x.h"
#include "main.h"
#include "delay.h"
#include "fmc.h"
#include "ota_message.h"

#include "boot.h"
#include "w25q32.h"
void task_fwdgt_reload(void);
OTA_STRUCT UpDataA;           //AõĽṹ

int main(void)
{
	Delay_Init();          
	W25Q32_Init();	
	OTA_MESSAGE *ota_data;
	task_fwdgt_reload();
	if(load_ota_message_config_params()==0)
	{
		//ota¼ˣBootloader֧
		ota_data=get_config_params();
		BootLoader_Brance(ota_data->XmodemByte);
	}
	//ûOTA¼תA
	else
	{
		LOAD_A(GD32_A_SADDR);
	}
  
	while(1)
	{
		
		
	}
	
}

void task_fwdgt_reload(void)
{
	/* uncock fwdgt write protect*/
	fwdgt_write_enable();
	/* feed fwdgt */
	fwdgt_counter_reload();	
}